/* ---------------------------------------------------------- */
/*  enemyobject.cpp                                           */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		GN҂̈̂̃IuWFNg
    @author		K.Kunikane (끗ӂ)
    @since		Feb.15.2005
    $Revision: 1.1.1.1 $
*/
/*-----------------------------------------------------
 Copyright (C) 2005 rero2@fumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "enemyobject.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
EnemyObject::EnemyObject()
{
  /* ---  */
  m_IsHit = false;
  m_HitWait = 0;
  m_WalkPattern = 0;
  m_Charactor = 0;
  m_Score = 0;
}


/**
 * fXgN^(n)
 */
EnemyObject::~EnemyObject()
{
}



/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- Init() */
/**
 * ԏ
 *
 * @return 
 *
 */
void EnemyObject::Init()
{
  m_IsHit = false;
  m_HitWait = 0;
}


/* ----------------------------------------- */
/* --- Tick() */
/**
 * t[Ƃ̍(ؖԂ)
 *
 * @return true ȂړAfalse Ȃ
 *
 */
bool EnemyObject::Tick()
{
  bool  result;

  result = true;
  if (m_IsHit == true) {
    /* - qbg}[N\ */
    m_TexU = 2 * 32;
    m_TexV = m_Charactor * 48;
    /* - ẽt[Y */
    if (m_HitWait > 0) {
      m_HitWait -= 1;
    }
    else {
      result = false;
    }
  }

  return(result);
}


/* ----------------------------------------- */
/* --- Hit() */
/**
 * eɂ`
 *
 * @return 
 *
 */
void EnemyObject::Hit()
{
  m_IsHit = true;
  m_HitWait = ENEMYHIT_WAIT;
  /* - Ôߓ蔻Ȃ */
  m_HitEnable = false;
}


/* ----------------------------------------- */
/* --- SetWalkPattern() */
/**
 * GLN^[̊Gw肷
 *
 * @return 
 *
 */
void EnemyObject::SetWalkPattern(int pattern)
{
  int n;

  /* - eNX`w */
  m_WalkPattern = pattern;
  /*  2p^[Ȃ */
  n = pattern % 2;
  m_TexU = n * 32;
  m_TexV = m_Charactor * 48;
}


/* ----------------------------------------- */
/* --- SetCharactor() */
/**
 * LN^[̎w
 *
 * @return 
 *
 */
void EnemyObject::SetCharactor(int chara)
{
  m_Charactor = chara;
  /* - ɔf */
  m_TexU = (m_WalkPattern % 2) * 32;
  m_TexV = m_Charactor * 48;
}


/* ----------------------------------------- */
/* --- SetScore() */
/**
 * XRAݒ肷
 *
 * @param score [in] ̃IuWFNg̓_
 * @return 
 *
 */
void EnemyObject::SetScore(int score)
{
  m_Score = score;
}


/* ----------------------------------------- */
/* --- GetScore() */
/**
 * XRAݒ肷
 *
 * @return 
 *
 */
int EnemyObject::GetScore()
{
  return(m_Score);
}




/*------------------------------------------------------*/
/* local work                                           */
/*------------------------------------------------------*/

