/* ---------------------------------------------------------- */
/*  myshipmanage.cpp                                          */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		@ǗNX
    @author		K.Kunikane (끗ӂ)
    @since		Feb.14.2005
    $Revision: 1.1.1.1 $
*/
/*-----------------------------------------------------
 Copyright (C) 2005 rero2@fumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "myshipmanage.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
MyShipManage::MyShipManage()
{
  /* ---  */
  // m_ShotMan = null;
  m_IsHit = false;
  m_Wait = 0;
  m_Timer = 0;
  m_Bank = 0;
}


/**
 * fXgN^(n)
 */
MyShipManage::~MyShipManage()
{
}



/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- SetMyShotMan() */
/**
 * @e̊ǗCX^X󂯎
 *
 * @param shot [in] @ẽ}l[WCX^X
 * @return 
 *
 */
#if 0
void MyShipManage::SetMyShotMan(MyShotManage* shot)
{
  m_MyShotMan = shot;
}
#endif


/* ----------------------------------------- */
/* --- Init() */
/**
 * 
 * Q[JnɈ񂾂R[
 *
 * @return 
 *
 */
void MyShipManage::Init()
{
  /* --- IuWFNg̏ */
  m_SizeW = 32;
  m_SizeH = 48;
  m_Priority = BS_DEPTH_MYSHIP;
  m_Blend = 1.0;
  m_Zoom = 1.0;
  m_TexU = 0;
  m_TexV = 48 * SIENSIDE;
  m_TexW = 32;
  m_TexH = 48;
  m_PosCenter = true;
  m_Working = true;
  m_Visible = true;

  /* --- 蔻 */
  SetHitSize(1.0);
  SetGrazeSize(4.0);
  m_HitEnable = true;
  m_GrazeEnable = true;

  /* --- ʒu */
  m_PosX = GAMEFIELD_W / 2;
  m_PosY = GAMEFIELD_H - 8 - (m_SizeH / 2);
  
}


/* ----------------------------------------- */
/* --- SetHitState() */
/**
 * G̒eH炱炻̎|ĂĂ
 *
 * @param hit [in] eɂȂ true
 * @return ߂ēȂ true (SEp̃^[)
 *
 */
bool MyShipManage::SetHitState(bool hit)
{
  bool hitnow;

  hitnow = false;
  if (hit) {
    m_IsHit = hit;
    /* -- e炢 SE p^[ */
    hitnow = true;
  }

  return(hitnow);
}


/* ----------------------------------------- */
/* --- GetHitState() */
/**
 * G̒eH炢ς݂ǂ𓾂
 *
 * @return eHȂ true ʏԂ false
 *
 */
bool MyShipManage::GetHitState()
{
  return(m_IsHit);
}


/* ----------------------------------------- */
/* --- Tick() */
/**
 *  @ړǗ
 * t[R[
 *
 * @param inkey [in] vC[
 * @return 
 *
 */
bool MyShipManage::Tick(unsigned long inkey,
			unsigned long inkey_triger)
{
  m_Timer += 1;

  /* --- qbgŃQ[I[o[܂ł̗]C */
  if (m_IsHit == true) {
    m_Wait += 1;
    if (m_Wait >= 45) {
      /* -- Q[I */
      return(false);
    }
    /* -- ƃEFCg */
    return(true);
  }

  /* --- Vbg */
  if (inkey_triger & BS_INPUT_BUTTON1) {
    /* -- MyShotManage mFAɂłĂȂ */
    /* ===== */
  }

  /* --- ړ */
  if (((inkey & BS_INPUT_LEFT) > 0) &&
      ((inkey & BS_INPUT_RIGHT) > 0)) {
    /* -- ͖ɂ */
    /* ̃R}΍(R) */
    m_Bank = 0;
  }
  else if(inkey & BS_INPUT_LEFT) {
    /* -- ړ */
    if (m_PosX > 24.0) {
      m_PosX -= 4.0;
    }
  }
  else if(inkey & BS_INPUT_RIGHT) {
    /* -- Eړ */
    if (m_PosX < (GAMEFIELD_W - 24.0)) {
      m_PosX += 4.0;
    }
  }
  
}





/*------------------------------------------------------*/
/* local work                                           */
/*------------------------------------------------------*/

