/* ---------------------------------------------------------- */
/*  SpriteItem.h                                              */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		XvCgNX
    @author		K.Kunikane (끗ӂ)
    @since		Feb.13.2005
    $Revision: 1.1.1.1 $
*/
/*-----------------------------------------------------
 Copyright (C) 2005 rero2@fumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef SPRITEITEM_H
#define SPRITEITEM_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "luna.h"
#include "lunavader.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * @brief XvCgǗNX
 *        XvCg11CX^X
 *        Luna system G炸ɃXvCg\ł悤
 *
 * @todo -
 * @bug -
 */
class SpriteItem
{
  /* ----------------------------------- */
  /* --- RXgN^EfXgN^ */
 public:
  SpriteItem();
  virtual  ~SpriteItem();

  /* ----------------------------------- */
  /* --- pubNo */
 public:
  //! \ʒu(XvCg) X
  float m_PosX;
  //! \ʒu(XvCg) Y
  float m_PosY;
  //! \TCY
  int m_SizeW;
  //! \TCYc
  int m_SizeH;
  //! \[x(vCIeB)
  int m_Priority;
  //! l(1.0 ŕsA0.0 œ)
  float m_Blend;
  //! w\TCY傫菬
  float m_Zoom;
  //! eNX`W U
  int m_TexU;
  //! eNX`W V
  int m_TexV;
  //! eNX`W
  int m_TexW;
  //! eNX`Wc
  int m_TexH;
  //! ʏ Z]
  float m_RollZ;
  //! 3DW] X
  float m_RollX;
  //! 3DW] Y
  float m_RollY;
  //! W̓XvCg̒Sۂ
  bool m_PosCenter;
  //! gpۂ(ړ炵Ȃ)
  bool m_Working;
  //! \邩ۂ(ړƂ͂)
  bool m_Visible;

  /* ----------------------------------- */
  /* --- vCx[go */
 protected:
  //! v~eBu[߂ LunaSprite nh
  LSPRITE m_LunaSprite;

  /* ----------------------------------- */
  /* --- pubN\bh */
 public:
  void SetLunaSprite(LSPRITE sp_handle);
  virtual bool Display();

  /* ----------------------------------- */
  /* --- vCx[g\bh */
 private:

};


#endif

